(* Imperative Liste *)
(* Die Funktionen orientieren sich an der STL von C++ *)

signature IList = sig

  type 'a IList
  type 'a ListNode

  (* erstellt eine leere Liste *)
  val empty     : unit -> 'a IList  
  
  (* Testet, ob die Liste leer ist *)
  val isEmpty   : 'a IList -> bool
  (* Gibt die Anzahl der Elemente in der Liste zurck *)
  val size      : 'a IList -> int

  (* liefert das erste bzw. das LAST-Element *)
  val first     : 'a IList -> 'a ListNode
  val last      : 'a IList -> 'a ListNode

  (* luft forwrts/rckwrts durch die Liste *)
  val next      : 'a ListNode -> 'a ListNode                 (* Empty *)
  val prev      : 'a ListNode -> 'a ListNode                 (* Empty *)

  (* liefert den Wert eines Listenelements *)
  val value     : 'a ListNode -> 'a

  (* Hat der Knoten eine Sonderfunktion? *)
  val isFirst   : 'a ListNode -> bool
  val isEnd     : 'a ListNode -> bool


  (* Einfgen eines Elementes VOR dem genannten Knoten *)
  val insert    : 'a IList * 'a ListNode * 'a -> 'a ListNode (* Empty *)
  
  (* Lschen des aktuellen Knotens *)
  val erase     : 'a IList * 'a ListNode -> 'a               (* Empty *)

  (* Lscht die ganze Liste *)
  val clear     : 'a IList -> unit

  (* Liefert den Wert des ersten/letzten Elementes *)
  val front     : 'a IList -> 'a                             (* Empty *)
  val back      : 'a IList -> 'a                             (* Empty *)

  (* Fgt neue Elemente hinzu *)
  val pushFront : 'a IList * 'a -> 'a ListNode
  val pushBack  : 'a IList * 'a -> 'a ListNode

  (* Lscht Elemente am Rand *)
  val popFront  : 'a IList -> 'a                             (* Empty *)
  val popBack   : 'a IList -> 'a                             (* Empty *)

  (* Gewhnliches Mapping *)
  val imap      : ('a ListNode -> unit) -> 'a IList -> unit

  (* Erstellt eine Kopie der Liste *)
  val copy      : 'a IList -> 'a IList 

end


