signature Interface = sig

type tree = int

datatype exp =
    Const  of string
  | App    of exp*exp
  | Tree   of tree
  | Var    of string
  | Mu     of string * exp
  | Lambda of string * exp

exception NotClosed

val enter: exp -> tree
val equal: tree * tree -> bool
val return: tree -> exp

(*******************)

val TypToString : exp -> string

end
