(* Endliche Funktionen *)

structure Map :> Map = 
struct
    datatype color = R | B
    datatype 'a ctree = E | N of color * 'a ctree * 'a * 'a ctree

    type ('a,'b) map = (('a*'b) ctree) * ('a * 'a -> order)
    fun emptymap cmp = (E, cmp)

    (*fun lookup ((nil,cmp),y) = NONE
  | lookup (((x,fx)::xr,cmp),y) = if cmp(x,y)=EQUAL then SOME fx else lookup((xr,cmp),y)
     
fun insertmap ((s,cmp),pair) =
     let
	 fun insertmap' (nil,(x,fx)) = (x,fx)::nil
	   | insertmap' ((a,fa)::lr,(x,fx)) = if cmp(x,a)=EQUAL then (x,fx)::lr
					       else (a,fa)::(insertmap'(lr,(x,fx)))
      in
	  (insertmap' (s,pair),cmp)
end*)
	
    fun rotate (x,y,z,a,b,c,d) = N(R, N(B,a,x,b), y, N(B,c,z,d))
	
    fun rotateL (B, N(R,N(R,a,x,b),y,c), z, d) = rotate(x,y,z,a,b,c,d)
      | rotateL (B, N(R,a,x,N(R,b,y,c)), z, d) = rotate(x,y,z,a,b,c,d)
      | rotateL         body                   = N body
	
    fun rotateR (B, a, x, N(R,b,y,N(R,c,z,d))) = rotate(x,y,z,a,b,c,d)
      | rotateR (B, a, x, N(R,N(R,b,y,c),z,d)) = rotate(x,y,z,a,b,c,d)
      | rotateR         body                   = N body
	
	
    fun insertmap ((a,cmp),(y,fy)) =
	let
	    fun insert' (y, E)            = N(R,E,y,E)
	      | insert' (y, N(color,a,x,b)) = 
		case cmp(#1 y,#1 x) of
		    LESS    => rotateL(color, insert'(y,a), x, b)
		  | EQUAL   => N(color,a,y,b)
		  | GREATER => rotateR(color, a, x, insert'(y,b))
	in
	    case insert'((y,fy),a) of
		N(_,a,x,b) => (N(B,a,x,b),cmp)
	      | E          => (E,cmp)
	end
    
    fun lookup ((E,cmp),y) = NONE
      | lookup ((N(_,a,(x,fx),b),cmp),y) = case cmp(y,x) of
	LESS => lookup((a,cmp),y) 
      | GREATER => lookup((b,cmp),y) 
      | EQUAL => SOME fx
end


