
structure MyArray :> MyArray = 
struct

    open Dynarray;
    type ''a array = (''a Dynarray.array * int ref)

    fun update((a,n),i,x) = (Dynarray.update(a,i,x); n:=Int.max(!n,i+1))
    fun tabulate(i,f,s0) = (Dynarray.tabulate(i,f,s0),ref i)
    fun default (a,_) = Dynarray.default(a)
    fun array(i,s0) = (Dynarray.array(i,s0),ref i)
    fun sub((a,_),i) = Dynarray.sub(a,i)
    fun fromList(lst,s0) = (Dynarray.fromList(lst,s0),ref(length lst))
    fun subArray((a,_),i,j) = (Dynarray.subArray(a,i,j),ref(j-i+1))
    fun bound (a,_)  = Dynarray.bound(a)
    fun size (a,n) = let val s0 = Dynarray.default a
		     in while !n > 0 andalso Dynarray.sub(a,!n-1) = s0 do
			 n := !n - 1;
			!n 
		     end

    fun map_array f a =
	let val i = ref 0
	    val max = size a
	in while !i < max do
	    (f(sub(a,!i));i:= !i + 1)
	end
    
    fun map_array_write f a =
	let val i = ref 0
	    val max = size a
	in while !i < max do
	    (update(a,!i,f(sub(a,!i)));i:= !i + 1)
	end
    
    fun op_array (f,a0,a1) = 
	let val i = ref 0
	    val max = size a1
	in while !i < max do 
	    (update(a0,!i,f(sub(a0,!i),sub(a1,!i)));
	     i := !i + 1)
	end
    
    fun copy_array (a0,a1) = 
	let val i = ref 0
	    val max = size a0
	(*val _ = print ("arraysize: " ^ Int.toString max ^ " " ^ Int.toString(MyArray.size a1) ^"\n");*)
	in while !i < max do 
	    (update(a1,!i,sub(a0,!i));
	     i := !i + 1)
	(*if max <> MyArray.size a1 then raise Error ("fatal: copy_array" ^(Int.toString(MyArray.size a1))) else ()*)
	end

    fun toList a = 
	let 
	    val max = size a - 1
	    fun toList' i l = if i<0 then l else toList' (i-1) (sub(a,i)::l)
	in
	    toList' max nil
	end
end
