(* Partielle Funktionen *)

structure NaiveMap :> NaiveMap = 
struct
  type ('a,'b) map = ('a * 'b) list * ('a * 'a -> order)
  fun emptymap cmp = (nil,cmp)

  fun lookup ((ls,cmp),y) =
      let
	  fun lookup' (nil,y) = NONE
	    | lookup' ((x,fx)::xr,y) = if cmp(x,y)=EQUAL then SOME fx else lookup'(xr,y)
      in
	  lookup'(ls,y)
      end
  
  fun insertmap ((ls,cmp),(x,y)) =
      let
	  fun insertmap' (nil,(x,y)) = (x,y)::nil
	    | insertmap' ((a,b)::rest,(x,y)) = if cmp(a,x)=EQUAL then (x,y)::rest
				      else (a,b)::(insertmap'(rest,(x,y)))
      in
	  (insertmap'(ls,(x,y)),cmp)
      end

end

