signature Parser = sig

type token
type ''a Database

(* Abstrakte Syntax fr rekursive Typen *)
datatype ty = 
  Null 
| Unit 
| Arrow of ty*ty
| App of ty*ty
| Add of ty*ty
| Mul of ty list
| Id of string
| My of string*ty
| Lambda of string*ty

(* Berechnet aus einer token list einen Typ *)
val ty : token list -> ty option

(* Berechnet die Textuelle Darstellung eines Typs *)
val ty2str : ty -> string

end where type token = Lex.token
      and type ''a Database = ''a Database.Database
