(* Referenzen mit Vergleichsoperator *)
(* Verwendet die Struktur DummyRef, um Probleme beim berschreiben von ! und := zu vermeiden *)

signature Ref = sig
  eqtype 'a Ref

  (* Konstruktor *)
  val Ref: 'a -> 'a Ref

  (* Die blichen Zugriffsfunktionen *)
  val op! : 'a Ref -> 'a
  val op:= : 'a Ref * 'a -> unit 

  (* Vergleichsoperator auf Referenzen *)
  val cmp: 'a Ref * 'a Ref -> order

  (* Vergleichsoperator auf Paaren von Referenzen *)
  (* Prioritt hat die erste Komponente           *)
  val cmpPair: ('a Ref * 'b Ref) * ('a Ref * 'b Ref) -> order
end
  where type 'a Ref = int * 'a DummyRef.Ref
