signature TypeTrees = 
sig
    type ty
    type ''a Database
    type ''a Tree
    eqtype TyLabel   (* Label fr einen Baum, der Typen darstellt *)
    type 'a DBLTree  (* In der Datenbank genutzter Baumtyp        *)
    type ''a dbsig   (* Signatur der Bume in der Datenbank       *)
    eqtype 'a Ref

    (* Berechnet einen String aus einem Label *)
    val label2string : TyLabel dbsig -> string
 
    (* Wandelt ein Label in einen Integer um *)
    val label2int : TyLabel -> int

    (* Vergleicht zwei TyLabels *)
    val labelcmp : TyLabel * TyLabel -> order
 
    (* Berechnet aus einem Typ einen zyklischen Baum *)
    val tytree : TyLabel Database -> ty -> TyLabel dbsig DBLTree Ref

    (* Berechnet eine textuelle Darstellung eines Typs in 
       Form eines zyklischen Baumes *)
    val tytree2tystring : TyLabel Database -> TyLabel dbsig Tree Ref -> string

    (* Berechnet aus einem zyklischen Baum einen Typ *)
    val tytree2ty : TyLabel Database -> TyLabel dbsig Tree Ref -> ty

end
where type ''a Database = ''a Database.Database
      and type ty = Parser.ty
      and type ''a Tree = ''a Tree.Tree
      and type 'a DBLTree = 'a Database.DBLTree
      and type ''a dbsig = ''a Database.dbsig
      and type 'a Ref = 'a Ref.Ref
